program bestgomoku;
{$APPTYPE GUI}
{$R bestgomoku.res}

uses Windows,Display,Sysutils;

var i,j,k,l,m,n:longint;

var fis:string='bestgomoku.ini';
    fss:string='bestgomoku.sav';
    fls:string='lg\zh-cn.lg';
var f,fs,fl:text;

type point=record x,y,p:shortint;end;

var Title:string='Best Gomoku --- ';
    TitleRead:string='Read';
    TitleGet:string='Get';
    TitleChange:string='Change';
    TitleStop:string='Stop';
    TitleHelp:string='Help';
    TitleNew:string='New';
    TitleLoad:string='Load';
    TitleSave:string='Save';
    TitleSwap:string='Swap';
    TitleUndo:string='Undo';
    TitleRedo:string='Redo';
    TitleSize:string='Size';
    TitleSkin:string='Skin';
    TitleVolume:string='Volume';
    TitleHmAI:string='Hm|AI';
    TitleLevel:string='Level';
    TitleTime:string='Time';
    TitlePut:string='Put';
    TitleOpen:string='Open';
    TitleReset:string='Reset';
    TitleWait:string='Wait';
    TitleClose:string='Close';
    TitleMusic:string='Music';
    TitleSound:string='Sound';
    TitleInitial:string='Initial';

var TitleNow:string;
    TitleDraw:boolean;

const SizeMax=100;
var Size:shortint=15;
    Skin:shortint=1;
    SkinMax:shortint=10;
    AILevelMax:shortint=30;
    MemoryMax:longint=536870912;
    MusicMax:shortint=7;
    TimeMatch:longint=1000000;
    TimePause:DWord=200;
    TimeDurance:DWord=5000;

var bd:array[1..SizeMax,1..SizeMax]of shortint;
    Step:array[1..SizeMax*SizeMax]of point;
    StepNow:longint;
    StepMax:longint;
    Win:shortint;
    rx,ry,rp:shortint;

var MusicVol:shortint=50;
    SoundVol:shortint=50;
    Music:shortint;

var AISide,AISit,AISideNow,AINext,AIScore:array[1..2]of shortint;
    AIlevel:array[1..2]of shortint=(1,1);

var AITimeTurn:array[1..2]of longint=(2000,2000);

var AITimeNow:DWord;
    AITimeRemain:longint;

var ColorNow:shortint=2;
    Sidenow:shortint=1;

var NextStep:boolean;

procedure MakeTitle(s:string);
begin
TitleNow:=s;
TitleDraw:=true;
end;

procedure MakeSound(s:string);
begin
if (AISide[1]<>1) or (AISide[2]<>1) then
  begin
  PlaySound(s);
  SetAudioVolume(s,SoundVol);
  end;
end;

procedure MakeMusic(s:string);
begin
Playmusicrepeat(s);
SetAudioVolume(s,MusicVol);
end;

procedure SaveSetting();
begin
rewrite(f);
writeln(f,Size);
writeln(f,Skin);
writeln(f,SkinMax);
writeln(f,MemoryMax);
writeln(f,MusicMax);
writeln(f,MusicVol);
writeln(f,SoundVol);
writeln(f,AILevel[1]);
writeln(f,AILevel[2]);
writeln(f,AILevelMax);
writeln(f,AITimeTurn[1]);
writeln(f,AITimeTurn[2]);
writeln(f,TimeMatch);
writeln(f,TimePause);
writeln(f,TimeDurance);
writeln(f,fls);
close(f);
end;

procedure LoadSetting();
begin
reset(f);
readln(f,Size);
readln(f,Skin);
readln(f,SkinMax);
readln(f,MemoryMax);
readln(f,MusicMax);
readln(f,MusicVol);
readln(f,SoundVol);
readln(f,AILevel[1]);
readln(f,AILevel[2]);
readln(f,AILevelMax);
readln(f,AITimeTurn[1]);
readln(f,AITimeTurn[2]);
readln(f,TimeMatch);
readln(f,TimePause);
readln(f,TimeDurance);
readln(f,fls);
close(f);
MakeTitle(Title+TitleRead);
end;

procedure GetSetting();
begin
SetTitle(Title+TitleGet);
if FileExists(fis) then LoadSetting()
else SaveSetting();
end;

procedure GetLanguage();
begin
assign(fl,fls);
if FileExists(fls) then
  begin
  reset(fl);
  Readln(fl,Title);
  Readln(fl,TitleRead);
  Readln(fl,TitleGet);
  Readln(fl,TitleChange);
  Readln(fl,TitleStop);
  Readln(fl,TitleHelp);
  Readln(fl,TitleNew);
  Readln(fl,TitleLoad);
  Readln(fl,TitleSave);
  Readln(fl,TitleSwap);
  Readln(fl,TitleUndo);
  Readln(fl,TitleRedo);
  Readln(fl,TitleSize);
  Readln(fl,TitleSkin);
  Readln(fl,TitleVolume);
  Readln(fl,TitleHmAI);
  Readln(fl,TitleLevel);
  Readln(fl,TitleTime);
  Readln(fl,TitlePut);
  Readln(fl,TitleOpen);
  Readln(fl,TitleReset);
  Readln(fl,TitleWait);
  Readln(fl,TitleClose);
  Readln(fl,TitleMusic);
  Readln(fl,TitleSound);
  Readln(fl,TitleInitial);
  close(fl);
  end;
end;

{$include bestgomoku_draw.inc}

{$include bestgomoku_ai.inc}

procedure Change(sd:shortint);
begin
AISide[sd]:=1-AISide[sd];
DrawChange(sd);
if sd=SideNow then AINext[sd]:=1;
MakeTitle(Title+TitleChange+' '+i2s(sd));
end;

procedure Stop(sd:shortint);
begin
if AISide[sd]=1 then Change(sd);
MakeTitle(Title+TitleStop+' '+i2s(sd));
end;

procedure Stop();
begin
Stop(SideNow);
end;

procedure Help();
begin
MakeTitle(Title+TitleHelp);
BarTo(0,0,sz*(Size+1),sz*(Size+1),GetBGColor(),GetBGColor());
DrawStrBD(TitleNew,1,1);
DrawStrBD(TitleLoad,1,2);
DrawStrBD(TitleSave,1,3);
DrawStrBD(TitleSwap,1,4);
DrawStrBD(TitleStop,1,5);
DrawStrBD(TitleHelp,1,6);
DrawStrBD(TitleUndo,1,7);
DrawStrBD(TitleRedo,1,8);
DrawStrBD(TitleSize,1,9);
DrawStrBD(TitleSkin,1,10);
DrawStrBD(TitleVolume,1,11);
DrawStrBD(TitleHmAI,1,12);
DrawStrBD(TitleLevel,1,13);
DrawStrBD(TitleTime,1,14);
DrawPicBD(btm[1,1],5,1);
DrawPicBD(btm[1,2],5,2);
DrawPicBD(btm[1,3],5,3);
DrawPicBD(btm[2,1],5,4);
DrawPicBD(btm[2,2],5,5);
DrawPicBD(btm[2,3],5,6);
DrawPicBD(btm[3,1],5,7);
DrawPicBD(btm[3,2],6,7);
DrawPicBD(btm[3,3],7,7);
DrawPicBD(btm[4,1],5,8);
DrawPicBD(btm[4,2],6,8);
DrawPicBD(btm[4,3],7,8);
DrawPicBD(btm[5,3],5,9);
DrawStrBD('20',6,9);
DrawPicBD(btm[6,3],7,9);
DrawPicBD(btm[5,2],5,10);
DrawPicBD(bg[0],6,10);
DrawPicBD(btm[6,2],7,10);
DrawPicBD(btm[5,3],5,11);
DrawStrBD('50',6,11);
DrawPicBD(btm[6,3],7,11);
DrawPicBD(btm[5,1],5,12);
DrawPicBD(btm[6,1],6,12);
DrawStrBD('0',7,12);
DrawPicBD(btm[5,2],5,13);
DrawStrBD('9k',6,13);
DrawPicBD(btm[6,2],7,13);
DrawPicBD(btm[5,3],5,14);
DrawStrBD('20',6,14);
DrawPicBD(btm[6,3],7,14);
DrawStrBD('F2,N,B',9,1);
DrawStrBD('F3,L,O',9,2);
DrawStrBD('F4,S',9,3);
DrawStrBD('F9,tab,spc',9,4);
DrawStrBD('F12',9,5);
DrawStrBD('F1',9,6);
DrawStrBD('bsp,T,Y,U,del',9,7);
DrawStrBD('ins,W,E,R',9,8);
DrawStrBD('F5,F6',9,9);
DrawStrBD('F7,F8',9,10);
DrawStrBD('up,dn,lf,rg',9,11);
DrawStrBD('F10,F11,1,2',9,12);
DrawStrBD('3,4,5,6',9,13);
DrawStrBD('7,8,9,0',9,14);
repeat
NextMsg();
if IsMouseLeft() then break;
if IsKey() then break;
sleep(1);
until false;
NextMsg();
DrawAll();
end;

procedure Go();
begin
AINext[SideNow]:=1;
end;

procedure SwapSide();
begin
MakeSound('sound\set.mp3');
SideNow:=3-SideNow;
DrawSideColor(ColorNow,SideNow);
MakeTitle(Title+TitleSwap);
end;

procedure SwapColor();
begin
MakeSound('sound\set.mp3');
ColorNow:=3-ColorNow;
DrawSideColor(ColorNow,SideNow);
end;

procedure Swap();
begin
SideNow:=3-SideNow;
ColorNow:=3-ColorNow;
DrawSideColor(ColorNow,SideNow);
end;

procedure Next();
begin
Swap();
Go();
end;

procedure This();
begin
SwapSide();
Go();
end;

procedure IsWin();
begin
Win:=0;
for i:=1 to Size do
  for j:=1+2 to Size-2 do
    if (bd[i,j]<>0) and
       (bd[i,j]=bd[i,j-2]) and
       (bd[i,j]=bd[i,j-1]) and
       (bd[i,j]=bd[i,j+1]) and
       (bd[i,j]=bd[i,j+2]) then
      begin
      Win:=bd[i,j];
      DrawWin(i,j-2,i,j+2,Win);
      end;
for i:=1+2 to Size-2 do
  for j:=1 to Size do
    if (bd[i,j]<>0) and
       (bd[i,j]=bd[i-2,j]) and
       (bd[i,j]=bd[i-1,j]) and
       (bd[i,j]=bd[i+1,j]) and
       (bd[i,j]=bd[i+2,j]) then
      begin
      Win:=bd[i,j];
      DrawWin(i-2,j,i+2,j,Win);
      end;
for i:=1+2 to Size-2 do
  for j:=1+2 to Size-2 do
    if (bd[i,j]<>0) and
       (bd[i,j]=bd[i-2,j-2]) and
       (bd[i,j]=bd[i-1,j-1]) and
       (bd[i,j]=bd[i+1,j+1]) and
       (bd[i,j]=bd[i+2,j+2]) then
      begin
      Win:=bd[i,j];
      DrawWin(i-2,j-2,i+2,j+2,Win);
      end;
for i:=1+2 to Size-2 do
  for j:=1+2 to Size-2 do
    if (bd[i,j]<>0) and
       (bd[i,j]=bd[i+2,j-2]) and
       (bd[i,j]=bd[i+1,j-1]) and
       (bd[i,j]=bd[i-1,j+1]) and
       (bd[i,j]=bd[i-2,j+2]) then
      begin
      Win:=bd[i,j];
      DrawWin(i-2,j+2,i+2,j-2,Win);
      end;
if StepNow>=Size*Size then Win:=-1;
end;

procedure PutAI(x,y:shortint);
begin
if Win=0 then
if (bd[x,y]=0) then
  begin
  MakeSound('sound\click.mp3');
  AINext[SideNow]:=0;
  StepNow:=StepNow+1;
  StepMax:=StepNow;
  Step[StepNow].x:=x;
  Step[StepNow].y:=y;
  Step[StepNow].p:=ColorNow;
  DrawStep(StepNow);
  if getlasterror=87 then
    DrawStepAll();
  bd[x,y]:=ColorNow;
  IsWin();
  Next();
  NextStep:=true;
  MakeTitle(Title+TitlePut+' '+i2s(x)+' '+i2s(y)+' '+i2s(ColorNow));
  end
else
  begin
  Stop();
  DrawSit(SideNow,9);
  end;
end;

procedure Put(x,y:shortint);
begin
if bd[x,y]=0 then
  begin
  Stop();
  PutAI(x,y);
  end;
end;

procedure Undo();
begin
if StepNow>0 then
  begin
  Stop();
  Swap();
  bd[Step[StepNow].x,Step[StepNow].y]:=0;
  Step[StepNow].p:=0;
  DrawStep(StepNow);
  StepNow:=StepNow-1;
  IsWin();
  end;
end;

procedure Undo(n:longint);
begin
MakeSound('sound\undo.mp3');
for k:=1 to n do Undo();
MakeTitle(Title+TitleUndo+' '+i2s(n));
end;

procedure Redo();
begin
if StepNow<StepMax then
  begin
  StepNow:=StepNow+1;
  Step[StepNow].p:=ColorNow;
  bd[Step[StepNow].x,Step[StepNow].y]:=ColorNow;
  DrawStep(StepNow);
  Swap();
  IsWin();
  end;
end;

procedure Redo(n:longint);
begin
MakeSound('sound\redo.mp3');
for k:=1 to n do Redo();
MakeTitle(Title+TitleRedo+' '+i2s(n));
end;

procedure New();
begin
Music:=random(7)+1;
MakeMusic('music\main'+i2s(Music)+'.mp3');
MakeSound('sound\new.mp3');
if Win>0 then AIScore[3-Win]:=AIScore[3-Win]+1;
Win:=0;
Stop(1);
while (AISit[1]<>0) do sleep(1);
Stop(2);
while (AISit[2]<>0) do sleep(1);
StepNow:=0;
StepMax:=0;
for i:=1 to Size do
  for j:=1  to Size do
    bd[i,j]:=0;
DrawAll();
MakeTitle(Title+TitleNew);
end;

procedure Restart();
begin
AISideNow[1]:=AISide[1];
AISideNow[2]:=AISide[2];
New();
if AISideNow[2]=1 then Change(2);
if AISideNow[1]=1 then Change(1);
end;

procedure OnAI(sd:shortint);
begin
MakeTitle(Title+TitleOpen+' '+i2s(sd));
OpenAI(sd);
WriteAI(sd,'START '+i2s(Size));
WriteAI(sd,'INFO max_memory '+i2s(MemoryMax));
WriteAI(sd,'INFO timeout_match '+i2s(TimeMatch));
WriteAI(sd,'INFO timeout_turn '+i2s(AITimeTurn[sd]));
WriteAI(sd,'INFO game_type 0');
WriteAI(sd,'INFO rule 0');
//WriteAI(sd,'INFO folder %temp%');
AISit[sd]:=1;
DrawTime(sd,AITimeTurn[sd]);
end;

procedure SendAI(sd:shortint);
begin
if AISit[sd]=1 then
  begin
  WriteAI(sd,'INFO time_left '+i2s(TImeMatch));
  if StepNow=0 then
    WriteAI(sd,'BEGIN')
  else
    begin
    WriteAI(sd,'BOARD');
    for i:=1 to StepNow do
      WriteAI(sd,i2s(Step[i].x-1)+','+i2s(Step[i].y-1)+','+i2s(Step[i].p));
    WriteAI(sd,'DONE');
    end;
  end
else if AISit[sd]=2 then
  begin
  WriteAI(sd,'INFO time_left '+i2s(TImeMatch));
  WriteAI(sd,'TURN '+i2s(Step[StepNow].x-1)+','+i2s(Step[StepNow].y-1));
  end;
AISit[sd]:=2;
AITimeNow:=GetTime();
MakeTitle(Title+TitleReset+' '+i2s(sd));
end;

procedure ListenAI(sd:shortint);
var s,s1,s2:string;
    ps:longint;
    aix,aiy:shortint;
begin
SendAI(sd);
MakeTitle(Title+TitleWait+' '+i2s(sd));
repeat
s:=ReadAI(sd);
if (length(s)>=3) then
  begin
  if (s[1]='S') then
    begin
    ps:=pos(' ',s);
    s:=copy(s,ps+1,length(s)-ps);
    end;
  if (s[1]>='0') and (s[1]<='9') then
    begin
    ps:=pos(',',s);
    s1:=copy(s,1,ps-1);
    s2:=copy(s,ps+1,length(s)-ps-1);
    val(s1,aix,ps);
    val(s2,aiy,ps);
    if (AISide[sd]=1) and (AISit[sd]=2) then
      begin
      //PutAI(aix+1,aiy+1);
      rx:=aix+1;
      ry:=aiy+1;
      rp:=ColorNow;
      end;
    end;
  end;
DrawTime(sd,AITimeTurn[sd]);
sleep(1);
until not((AISide[sd]=1) and (AISit[sd]=2) and (AINext[sd]=1));
end;

procedure OffAI(sd:shortint);
begin
WriteAI(sd,'END');
MakeTitle(Title+TitleClose+' '+i2s(sd));
CloseAI(sd);
AISit[sd]:=0;
DrawSit(sd,9);
end;

procedure PlayAI(sd:shortint);
begin
repeat
if (AISide[sd]=0) and (AISit[sd]>0) then OffAI(sd);
if (AISide[sd]=1) and (AISit[sd]=0) then OnAI(sd);
if (AISide[sd]=1) and (AISit[sd]>0) and (AINext[sd]=1) then ListenAI(sd);
sleep(1);
until false;
end;

procedure PlayComputer1();
begin
PlayAI(1);
end;

procedure PlayComputer2();
begin
PlayAI(2);
end;

procedure SetSize(n:shortint);
begin
if (n>=5) and (n<=100) then
  begin
  Size:=n;
  ResetWin();
  New();
  MakeTitle(Title+TitleSize+' '+i2s(n));
  end;
SaveSetting();
end;

procedure SetSkin(n:shortint);
begin
if (n>=0) and (n<=SkinMax) then
  begin
  Skin:=n;
  ResetWin();
  MakeTitle(Title+TitleSkin+' '+i2s(n));
  end;
SaveSetting();
end;

procedure SetMusicVol(vol:shortint);
begin
MusicVol:=vol;
if MusicVol<0 then MusicVol:=0;
if MusicVol>100 then MusicVol:=100;
SetAudioVolume('music\main'+i2s(Music)+'.mp3',MusicVol);
DrawMusic();
MakeTitle(Title+TitleMusic+' '+i2s(MusicVol));
SaveSetting();
end;

procedure SetSoundVol(vol:shortint);
begin
SoundVol:=vol;
if SoundVol<0 then SoundVol:=0;
if SoundVol>100 then SoundVol:=100;
DrawSound();
MakeTitle(Title+TitleSound+' '+i2s(SoundVol));
SaveSetting();
end;

procedure SetAILevel(sd:shortint;lv:shortint);
begin
if (lv>0) and (lv<=AILevelMax) then
  begin
  AISideNow[sd]:=AISide[sd];
  Stop(sd);
  while AISit[sd]<>0 do sleep(1);
  AILevel[sd]:=lv;
  DrawLevel(sd);
  MakeTitle(Title+TitleLevel+' '+i2s(sd)+' '+i2s(lv));
  if AISideNow[sd]=1 then Change(sd);
  end;
SaveSetting();
end;

procedure SetAITime(sd:shortint;t:real);
begin
k:=AITimeTurn[sd];
while (abs(k)>=10) do k:=k div 10;
if t=1 then
  case k of
    1:t:=2;
    2:t:=2.5;
    5:t:=2;
    end;
if t=-1 then
  case k of
    1:t:=0.5;
    2:t:=0.5;
    5:t:=0.4;
    end;
AITimeTurn[sd]:=round(AITimeTurn[sd]*t);
if (AITimeTurn[sd]<100) then AITimeTurn[sd]:=100;
if (AITimeTurn[sd]>1000000) then AITimeTurn[sd]:=1000000;
DrawTime(sd,AITimeTurn[sd]);
MakeTitle(Title+TitleTime+' '+i2s(sd)+' '+i2s(AITimeTurn[sd]));
SaveSetting();
end;

procedure Load();
begin
if FileExists(fss) then
  begin
  MakeSound('sound\set.mp3');
  reset(fs);
  readln(fs,Size);
  SetSize(Size);
  readln(fs,StepMax);
  for k:=1 to StepMax do
    with Step[k] do
      begin
      readln(fs,x,y,p);
      bd[x,y]:=p;
      end;
  close(fs);
  StepNow:=StepMax;
  DrawAll();
  MakeTitle(Title+TitleLoad);
  end;
end;

procedure Save();
begin
MakeSound('sound\set.mp3');
rewrite(fs);
writeln(fs,Size);
writeln(fs,StepMax);
for k:=1 to StepMax do
  with Step[k] do
    writeln(fs,x,' ',y,' ',p);
close(fs);
MakeTitle(Title+TitleSave);
end;

procedure PlayPlayer(sd:shortint);
var mx,my:longint;
    fx,fy:shortint;
    fr:longint;
begin
repeat
NextMsg();
if GetPixel(1,1)=WHITE then DrawAll();
if TitleDraw then begin SetTitle(TitleNow);TitleDraw:=false;end;
if IsMouseLeft() then
  begin
  mx:=GetMousePosX();

  my:=GetMousePosY();
  if (mx<size*sz) and (my<size*sz) then
    Put(mx div sz+1,my div sz+1)
  else if (mx>=sz*(size+1)) then
    begin
    fx:=(mx-sz*(size+1))div zm+1;
    fy:=my div zm+1;
    fr:=fy*10+fx;
    case fr of
      11:Restart();
      12:Load();
      13:Save();
      21:This();
      22:Stop();
      23:Help();
      31:Undo(StepNow);
      32:Undo(2);
      33:Undo(1);
      41:Redo(StepMax-StepNow);
      42:Redo(2);
      43:Redo(1);
      51:SetSize(Size-1);
      53:SetSize(Size+1);
      61:SetSkin(Skin-1);
      63:SetSkin(Skin+1);
      71:SetMusicVol(MusicVol-5);
      73:SetMusicVol(MusicVol+5);
      81:SetSoundVol(SoundVol-5);
      83:SetSoundVol(SoundVol+5);
      91:Change(1);
      101:SetAILevel(1,AILevel[1]-1);
      103:SetAILevel(1,AILevel[1]+1);
      111:SetAITime(1,-1);
      113:SetAITime(1,+1);
      121:Change(2);
      131:SetAILevel(2,AILevel[2]-1);
      133:SetAILevel(2,AILevel[2]+1);
      141:SetAITime(2,-1);
      143:SetAITime(2,+1);
      end;
    end;
  end;
if IsMouseRight() then
  Undo(1);
if IsMouseWheel() then
  begin
  if (_ms.wParam<0) then Undo(1);
  if (_ms.wParam>0) then Redo(1);
  end;
if IsKey() then
  begin
  k:=GetKey();
  case k of
    K_F1:Help();
    K_F2:Restart();
    K_F3:Load();
    K_F4:Save();
    K_F5:SetSize(Size-1);
    K_F6:SetSIze(Size+1);
    K_F7:SetSkin(Skin-1);
    K_F8:SetSkin(Skin+1);
    K_F9:This();
    K_F10:Change(1);
    K_F11:Change(2);
    K_F12:Stop();
    K_N:Restart();
    K_B:Restart();
    K_L:Load();
    K_O:Load();
    K_S:Save();
    K_TAB:This();
    K_SPACE:This();
    K_CLEAR:Stop();
    K_HELP:Help();
    K_T:Undo(StepNow);
    K_Y:Undo(2);
    K_U:Undo(1);
    K_E:Redo(2);
    K_R:Redo(1);
    K_BACK:Undo(1);
    K_DELETE:Undo(1);
    K_INSERT:Redo(1);
    K_W:Redo(StepMax-StepNow);
    K_HOME:Undo(StepNow);
    K_PRIOR:Undo(2);
    K_END:Redo(StepMax-StepNow);
    K_NEXT:Redo(2);
    K_LEFT:SetSoundVol(SoundVol-1);
    K_RIGHT:SetSoundVol(SoundVol+1);
    K_UP:SetMusicVol(MusicVol+1);
    K_DOWN:SetMusicVol(MusicVol-1);
    K_1:Change(1);
    K_2:Change(2);
    K_3:SetAILevel(1,AILevel[1]-1);
    K_4:SetAILevel(1,AILevel[1]+1);
    K_5:SetAILevel(2,AILevel[2]-1);
    K_6:SetAILevel(2,AILevel[2]+1);
    K_7:SetAITime(1,-1);
    K_8:SetAITime(1,+1);
    K_9:SetAITime(2,-1);
    K_0:SetAITime(2,+1);
    K_ESCAPE:Halt();
    end;
  end;
if (rp<>0) and not(NextStep) then
  begin
  PutAI(rx,ry);
  rp:=0;
  rx:=0;
  ry:=0;
  end;
sleep(1);
until NextStep;
end;

procedure Play();
begin
NewThread(@PlayComputer1);
NewThread(@PlayComputer2);
repeat
NextStep:=false;
PlayPlayer(SideNow);
sleep(1);
if (Win<>0) and (AISide[1]=1) and (AISide[2]=1) then
  begin
  sleep(TimePause);
  Restart();
  end;
sleep(1);
until false;
end;

procedure Init();
begin
Randomize();
assign(f,fis);
assign(fs,fss);
GetSetting();
GetLanguage();
LoadButtom();
SetSize(Size);
MakeTitle(Title+'by ax_pokl');
end;

begin
Init();
Play();
end.
